
int foodX = 0;
int foodY = 0;
Gnat[] myGnat;
int totalGnats = 1;
int max = 200;

void simulateGnats(){
  for(int i=0;i<totalGnats;i++){
    if(myGnat[i].alive()){
      if (myGnat[i].colliding()){ 
        if(totalGnats<(max-2)){

          myGnat[totalGnats] = new Gnat(foodX,foodY);
          totalGnats++;
        }
        foodX = int(random(0,width));
        foodY = int(random(0,height));
        ellipse(foodX,foodY,5,5);
      }
      myGnat[i].move();
      myGnat[i].display();


    }
  }



}

void setup()
{
  size(640,480);
  stroke(255);
  foodX = int(random(0,width));
  foodY = int(random(0,height));
  smooth();
  myGnat = new Gnat[max];
  myGnat[0] = new Gnat(200,200);
}


void draw(){
  background(0);
  ellipse(foodX,foodY,5,5);

  if(mousePressed){
    foodX=mouseX;
    foodY=mouseY;
  }
  simulateGnats();

}


class Gnat {
  int positionY=200;
  int positionX=200;
  int range=1;
  int countervar = 0;
  float swayy=5.0;
  float swayx=5.0;
  float distance=0;
  float randY = 0.0;
  float randX = 0.0;
  int swaymodifier=6;
  boolean alivevar;

  Gnat(int spawnX, int spawnY){
    positionX=spawnX;
    positionY=spawnY;
    alivevar=true;
  }
  void setcounter(int temp){
    countervar+=temp;
  }
  int counter(){
    return countervar;
  }
  void display(){
    if(alive()){
      stroke(255-int(counter()/8));
      point(positionX,positionY);
    }
  }
  float swayX(){
    if(foodX>positionX){
      swayx=swayx+((10-swayx)/swaymodifier);
    }
    else {
      swayx=swayx-(swayx/swaymodifier);
    }
    return swayx;
  }
  float swayY(){
    if(foodY>positionY){
      swayy=swayy+((10-swayy)/swaymodifier);
    }
    else {
      swayy=swayy-(swayy/swaymodifier);
    }
    return swayy;
  }
  void move(){
    range = int(distance()/random(10,20)) + 2;
    randY = random(0.0,10.0);
    randX = random(0.0,10.0);
    setcounter(1);
    if(counter()%5==0){
      swayy=5.0;
      swayx=5.0;
      
    }
    if(counter()==20000){
      kill();
      //setcounter(-counter());
    }
    if(counter()>20000){
      setcounter(-counter());
    }

    if(randX<=swayX()){
      positionX=constrain(positionX+range,0,width);
      positionY=constrain(positionY,0,height);
    }

    if(randX>swayX()){
      positionX=constrain(positionX-range,0,width);
      positionY=constrain(positionY,0,height);
    }

    if(randY<=swayY()){
      positionX=constrain(positionX,0,width);
      positionY=constrain(positionY+range,0,height);
    }

    if(randY>swayY()){
      positionX=constrain(positionX,0,width);
      positionY=constrain(positionY-range,0,height);
    }
  }
  float distance(){
    return sqrt((positionX-foodX)^2+(positionY-foodY)^2);
  }
  boolean colliding(){
    if(distance()<2){
      return true;
    } 
    else {
      return false;
    }
  }
  boolean alive(){
    return alivevar;
  }
  void kill(){
    alivevar=false;
  }



}


class Swarm {
  int positionY=200;
  int positionX=200;
  int range=1;
  int countervar = 0;
  float swayy=5.0;
  float swayx=5.0;
  float distance=0;
  float randY = 0.0;
  float randX = 0.0;
  int swaymodifier=6;
  boolean alivevar;

  Swarm(int spawnX, int spawnY){
    positionX=spawnX;
    positionY=spawnY;
    alivevar=true;
  }
  void setcounter(int temp){
    countervar+=temp;
  }
  int counter(){
    return countervar;
  }
  void display(){
    if(alive()){
      stroke(255-int(counter()/4));
      point(positionX,positionY);
    }
  }
  float swayX(){
    if(foodX>positionX){
      swayx=swayx+((10-swayx)/swaymodifier);
    }
    else {
      swayx=swayx-(swayx/swaymodifier);
    }
    return swayx;
  }
  float swayY(){
    if(foodY>positionY){
      swayy=swayy+((10-swayy)/swaymodifier);
    }
    else {
      swayy=swayy-(swayy/swaymodifier);
    }
    return swayy;
  }
  void move(){
    range = int(distance()/random(10,20)) + 2;
    randY = random(0.0,10.0);
    randX = random(0.0,10.0);
    setcounter(1);
    if(counter()%5==0){
      swayy=5.0;
      swayx=5.0;
      
    }
    if(counter()>1000){
      kill();
      //setcounter(-counter());
    }
    if(counter()>20000){
      setcounter(-counter());
    }

    if(randX<=swayX()){
      positionX=constrain(positionX+range,0,width);
      positionY=constrain(positionY,0,height);
    }

    if(randX>swayX()){
      positionX=constrain(positionX-range,0,width);
      positionY=constrain(positionY,0,height);
    }

    if(randY<=swayY()){
      positionX=constrain(positionX,0,width);
      positionY=constrain(positionY+range,0,height);
    }

    if(randY>swayY()){
      positionX=constrain(positionX,0,width);
      positionY=constrain(positionY-range,0,height);
    }
  }
  float distance(){
    return sqrt((positionX-foodX)^2+(positionY-foodY)^2);
  }
  boolean colliding(){
    if(distance()<2){
      return true;
    } 
    else {
      return false;
    }
  }
  boolean alive(){
    return alivevar;
  }
  void kill(){
    alivevar=false;
  }



}










